{ Include file for GWInfo. Drive detection code }

procedure partition(drive:byte; cs:word);    {display partition info *****}
var                                          {re-entrant procedure}
  i,k : byte;
  j : 0..3;
  buffer : array[0..512] of byte;
  nopart,xbool1,xbool2,xbool3,xbool4 : boolean;
  xbyte : byte;
  xlong,xlong2 : longint;
  xword : word;
  temp,line:string;

begin
  {afound:=false;}
  nopart:=true;
  i:=$7F+drive;
  xbool1:=false;
  xbool2:=false;
  if cs=1 then addline(' Drive '+num2str(drive)+' partitions:');
  repeat
    with regs do begin
      AX:=$0201;     {read 1 sector}
      CX:=cs;        {ccccccccCcssssss}
      DX:=i;         {hhhhhhhhdddddddd}
      ES:=seg(buffer);
      BX:=ofs(buffer);
      intr($13, regs);
      if regs.flags and fcarry = $0000 then begin
        xbool1:=true;
        xbool2:=true
      end
      else
        if i < $99 then inc(i)
        else xbool1:=true
      end
  until xbool1;
  if xbool2 then begin
{    xbool3:=false;
    repeat         }
      for j:=0 to 3 do begin
        xword:=$01BE + j shl 4;
        xbyte:=buffer[xword + 4];
        if xbyte > $00 then begin
{          temp:='  '+num2str(j+1)+': ';}
          nopart:=false;
          case xbyte of
            $01 : line:='FAT12';
            $02,$03 : line:='XENIX';
            $04 : line:='FAT16';
            $05 : begin cs:=(buffer[xword+3] shl 8)+buffer[xword+2];
                  partition(drive, cs); line:='E'; end;
            $06 : line:='Big FAT16';
            $07 : line:='NTFS';
            $0A : line:='OS/2 Boot Manager';
            $0B : line:='FAT32';
            $0C : line:='FAT32 LBA';
            $0E : line:='FAT16 LBA';
            $0F : begin cs:=(buffer[xword+3] shl 8)+buffer[xword+2]; {fat32?}
                  partition(drive, cs); line:='E'; end;
            $11 : line:='Hidden FAT12';
            $14,$16 : line:='Hidden FAT16';
            $17 : line:='Hidden NTFS';
            $1B : line:='Hidden FAT32';
            $1C : line:='Hidden FAT32 LBA';
            $1E : line:='Hidden FAT16 LBA';
            $1F : begin cs:=(buffer[xword+3] shl 8)+buffer[xword+2]; {hidden}
                  partition(drive, cs); line:='E'; end;
            $44 : line:='GoBack Protected';
            $50,$53,$54 : line:='DiskManager';
            $51 : line:='Netware/DiskMan';
            $55 : line:='EZ-Drive';
            $64..$69 : line:='Netware';
            $81,$82,$83,$85 : Write('Linux');
            $86 : line:='FAT16 Stripe/Volume';
            $87 : line:='NTFS Stripe/Volume';
            $C6,$C7 : line:='Corrupt NT';
            $E3 : line:='FAT Read Only';
            $FF : line:='Hidden';
          else line:='Unknown: '+ hex(xbyte, 2)
          end;
{        line:=temp+line;                 }
        xbyte:=buffer[xword];
        case xbyte of
          $00 : {not active};
          $80 : begin line:=line+' (Active)'; {if i=$80 then afound:=true;} end;
        else
            line:=line+' Status '+hex(xbyte, 2)+'?'
        end;
          xbyte:=buffer[xword + 6];
{          xlong2:=0;
          for k:=11 downto 8 do
            xlong2:=xlong2 shl 8 + buffer[xword + k];}
          xlong:=0;
          for k:=15 downto 12 do
            xlong:=xlong shl 8 + buffer[xword + k];
{          addline(num2str(buffer[xword + 1])+'h '+num2str(buffer[xword + 2])+' '+num2str(buffer[xword + 3]));}
{          temp:=num2str(buffer[xword + 1])+'h '+num2str(buffer[xword + 3]+
          buffer[xword + 2] shl 2)+'c '+num2str((buffer[xword + 2] and 63))+'s';        }
          if line[1]<>'E' then addline('  '+num2str(longint(xlong div 2048))+'Mb = '+line);
        end;
{        else if (i=$80) and (j=0) then nopart:=true;}
      end; {4 prtn}
{      xbool4:=false;
      repeat
        if i < $99 then begin
          inc(i);
          with regs do begin
            AX:=$0201;
            CX:=$0001;
            DX:=i;
            ES:=seg(buffer);
            BX:=ofs(buffer);
            intr($13, regs);
            if regs.flags and fcarry = $0000 then begin
              xbool4:=true;
              addline('Disk 2 Partitions:');
            end
          end
        end
        else begin
          xbool3:=true;
          xbool4:=true;
        end
      until xbool4;
    until xbool3}
    end
  else begin
{    addline(' none - error');}
    exit;
  end;
{  if not afound then addline(' No Active partition found');}
  if nopart then addline(' No partitions found');
end;

function getascii (off_start, off_end : word):string;
var  loop, loop1 : word;
const ret_val : string = '';
begin
  loop1 := 1;
  for loop := off_start to off_end do
    begin
      ret_val[loop1] := char(hi(dd[loop]));
      inc (loop1);
      ret_val[loop1] := char(lo(dd[loop]));
      inc (loop1);
    end;
  ret_val[0] := char(succ(off_end-off_start)*2);
  for i:=1 to length(ret_val) do begin
    if (length(ret_val)>0) and ((ret_val[length(ret_val)]=' ') or (ret_val[length(ret_val)]=#0))
      then delete(ret_val,length(ret_val),1);
    if (length(ret_val)>0) and (ret_val[1]<=' ') then delete(ret_val,1,1);
  end;
  getascii := ret_val;
end;

function getascii2 (off_start, off_end : word):string;
var ret_val : string;
begin
  ret_val:=copy(idstring,off_start,off_end-off_start);
  while ret_val[length(ret_val)]=' ' do delete(ret_val,length(ret_val),1);
  if ret_val<>'' then while ret_val[1]=' ' do delete(ret_val,1,1);
  getascii2:= ret_val;
end;

function ataready:boolean;
var wait:integer;
begin
    wait:=0;
    while ((port[ports[loop]+7]<>$50) and (wait<500))
          and ((port[ports[loop]+7]<>$58) and (wait<500)) do begin
      delay(5);
      wait:=wait+1;
    end;
    if wait=500 then ataready:=false
    else ataready:=true;
end;

procedure hdd_id;                           {not used!!}
const
  outval : array[0..3] of byte = ($a0,$b0,$a0,$b0);

var
  num_drv,found_drv : byte;
  dd_off : word;
  size: longint;
{  ddc : array[0..511] of char absolute dd;}
{  reg : registers;}

begin
  num_drv := mem[$0040:$75];
  found_drv:=0;
  writeln(outfile,'Hard Drives: ',num_drv);
  for loop := 0 to 3 do begin
      { Get BIOS drive info }
      regs.ah := $08;            { Get drive info }
      regs.dl := $80+loop;    { Drive is 80H for Disk 0, 81H for Disk 1 }
      intr ($13,regs);
      if (regs.flags and fCarry=0) then  { All OK if carry not set }
        begin
          bios_head[loop] := regs.dh+1; { Heads are from 0 }
          bios_sec[loop] := regs.cl and $3F; { sec is bits 5 - 0 }
          bios_cyl[loop] := ((regs.cl and $C0) shl 2)+regs.ch+2; { +1 because
           starts from 0 and +1 for FDISK leaving one out }
          bios_div[loop]:=bios_head[loop] div 16;  {translation}
        end;
    if ataready then begin
      port[ports[loop]+6] := outval[loop];
      if ataready then ;
      port[ports[loop]+7] := $ec;
      delay(2) ;
      if ataready then begin
        for dd_off := 0 to 255 do
          dd[dd_off] := portw[ports[loop]];
        found_drv:=found_drv+1;
        write('.');
        size:=longint(bios_cyl[loop])*longint(bios_head[loop])
           *longint(bios_sec[loop]) div 1953;
        writeln (outfile,'IDE Drive ',loop+1,': ',num2str(size),' Mb');
        writeln (outfile,' Drive Info: ',getascii(27,46),', Serial#: ',
              getascii (10,19),', Firmware: ',getascii (23,26));
        writeln (outfile,' Drive Params: ', dd[1],' Cyl, ',dd[3],' Hd, ',dd[6],' Sect');
        write (outfile,' BIOS  Params: ',bios_cyl[loop],' Cyl, ',bios_head[loop],
               ' Hd, ',bios_sec[loop],' Sect');
        if bios_div[loop]>0 then writeln(outfile,' - Translates to ',
               bios_cyl[loop]*bios_div[loop],' Cyl')
        else writeln(outfile);
      end; {ata ready}
    end; {data ready}
  end; {loop}
  if found_drv<num_drv then
    writeln(outfile,num_drv-found_drv,' of the ',num_drv,' drives may be SCSI');
end;

procedure checkifatabusy(var error:boolean; ideport:word); {chk ide port status}
{ timeout occured   -> error = true
  ata error occured -> error = true
  not busy          -> error = false }
var ready:boolean;
    w:word;
    s:byte;
begin
  ready:=false;
  w:=0;
  while ((not ready) and (not error)) do begin
    inc(w);
    s:=port[ideport+7];
    delay(2);
    if ((s and 128)<>128)
    then ready:=true;
    error:=((w=0) and (ready=false)) or ((s and 1)=1);
  end;
end;

procedure idatadrive(ideport:word; loop:byte); {id ide hard drive}
var c,w:word;                                  {write result to open file}
    attempts,s:byte;
    ready,error:boolean;
    dd_off : word;
    size: longint;

begin
  {  asm cli end;  }
      regs.ah := $08;            { Get drive info }
      regs.dl := $80+loop;    { Drive is 80H for Disk 0, 81H for Disk 1 }
      intr ($13,regs);
      if (regs.flags and fCarry=0) then  { All OK if carry not set }
        begin
          bios_head[loop] := regs.dh+1; { Heads are from 0 }
          bios_sec[loop] := regs.cl and $3F; { sec is bits 5 - 0 }
          bios_cyl[loop] := ((regs.cl and $C0) shl 2)+regs.ch+2; { +1 because
           starts from 0 and +1 for FDISK leaving one out }
{          bios_div[loop]:=bios_head[loop] div 16;  {translation}
        end;

  error:=true;
  attempts:=1;
  while ((error) and (attempts<=9)) do begin
    error:=false;
{     checkifatabusy(error,ideport);}
    if (not error) then begin
      s:=port[ideport+6];                  {select master/slave}
      delay(2);
      if (loop=0) or (loop=2) then s:=(s and $ef)
      else s:=(s or $10);
{        checkifatabusy(error,ideport);}
      port[ideport+6]:=s;
      delay(2);
    end;
    error:=false;
    checkifatabusy(error,ideport);
    if (not error) then begin
      port[ideport+7]:=$ec; {identify drive}
      delay(2);
    end;
    ready:=false;
    c:=0;
    idstring:='';
    while ((not error) and (not ready)) do   {read id}
    begin
      checkifatabusy(error,ideport);
      s:=port[ideport+7]; {check if data present. (drq set)}
      delay(2);
      ready:=((s and 8)=0);
      if (not ready) then begin
        checkifatabusy(error,ideport);
        w:=portw[ideport]; {read word}
        delay(2);
        dd[c]:=w;

{        if (not error) and (c>9) and (c<50) then begin
          dd_off:=c*2;
          dd[dd_off-1]:=hi(w);
          dd[dd_off]:=lo(w);
        end;}

{        if ((c<=46) and (not error))
        then idstring:=idstring+chr(hi(w))+chr(lo(w));}
        inc(c);
      end;
    end; {read id}
    error:=(c<46);
    if (not error) then begin
{      for c:=10 to 46 do
       dd[c]:=ord(idstring[c]);}
        found_drv:=found_drv+1;
{        size:=longint(bios_cyl[loop])*longint(bios_head[loop])
           *longint(bios_sec[loop]) div 1953;}
        size:=longint(dd[1])*longint(dd[3])*longint(dd[6]) div 1953;
        if size>8450 then begin    {large LBA drive}
          li:=(longint(dd[61])*65535+longint(dd[60])) div 1953;
          if li>0 then size:=li;
        end;
{          addline(num2str(dd[61])+' '+num2str(dd[60]));
          addline(num2str((longint(dd[61])*65535+longint(dd[60])) div 2000)+'M');
          addline(num2str(longint((dd[58]*65535+dd[57]) div 2))+'k');
        end;}
        addline('IDE Drive '+num2str(found_drv)+': '+num2str(size)+' Mb');
        line:=getascii(27,46);
        for i:=1 to length(line)-1 do
         if (line[i]=' ') and (line[i+1]=' ') then begin
           delete(line,i,1);
           if (length(line)>i+1) then dec(i);
         end;
        addline(' Info: '+line+', Serial#: '+
              getascii(10,19)+', Firmware: '+getascii(23,26));
        addline(' Drive Params: '+num2str(dd[1])+' Cyl, '+num2str(dd[3])+' Hd, '+
           num2str(dd[6])+' Sect');
        if size<8415 then addline(' BIOS  Params: '+num2str(bios_cyl[loop])+' Cyl, '+
          num2str(bios_head[loop])+' Hd, '+num2str(bios_sec[loop])+' Sect');
        partition(found_drv,1);
{        if bios_div[loop]>1 then addline(line+' - Translates to '+
               num2str(bios_cyl[loop]*bios_div[loop])+' Cyl')
        else addline(line);}
{      while idstring[length(idstring)]=' ' do delete(idstring,length(idstring),1);
      if drive=1 then write(outfile,', ');
      write(outfile,idstring);}
    end;
{    asm
      sti
    end;}
    inc(attempts);
  end; {main loop}
  regs.ax:=0;  {reset controller+drives}
  regs.dl:=128;
  intr($13,regs);
end;

procedure checkifatapibusy(var error:boolean; ideport:word); {chk atapi ready}
{  timeout occured   -> error = true
  not busy          -> error = false }
var ready:boolean;
    w,r:word;
    s:byte;
begin
  ready:=false;
  w:=0;
  while ((not ready) and (not error)) do begin
    s:=port[ideport+7];
    if ((s and 128)=128)
    then inc(w)
    else ready:=true;
    error:=((w=0) and (ready=false)) ;
  end;
end;

procedure idatapidrive(ideport:word; drive:byte); {id atapi drive }
var ready,error:boolean;
    s,loop:byte;
    c,w:word;
    attempts:byte;
begin
  error:=true;
  attempts:=1;
  while ((error) and (attempts<=9)) do begin
    error:=false;
    checkifatapibusy(error,ideport);
    s:=port[ideport+6];
    delay(1);
    if (drive=0) then s:=(s and $ef)
    else s:=(s or $10);
    error:=false;
    checkifatapibusy(error,ideport);
    port[ideport+6]:=s;
    delay(1);
    error:=false;
    checkifatapibusy(error,ideport);
    port[ideport+7]:=$08;
    delay(1);
    error:=false;
    checkifatapibusy(error,ideport);
    if (not error) then begin
      port[ideport+7]:=$a1;
      delay(1);
      ready:=false;
      c:=0;
      idstring:='';                           {cmd controllers dont error}
      while ((not error) and (not ready)) and (c<50) do begin
        checkifatapibusy(error,ideport);
        s:=port[ideport+7]; {check if data present. (drq set)}
        delay(1);
        ready:=((s and 8)=0);
        if ((not ready) and (not error)) then begin
          checkifatapibusy(error,ideport);
          w:=portw[ideport]; {read word}
          delay(1);
          dd[c]:=w;
          if ((c>=27) and (c<=46) and (not error)) {monitor for crap response}
          then idstring:=idstring+chr(hi(w)) + chr(lo(w));
{          error:=(c<46); { then begin  {for bad controllers that}
{          if (ord(idstring[length(idstring)]) >165) or
           (ord(idstring[length(idstring)]) <32) then begin idstring:='';
{               write(ord(idstring[length(idstring)])) end;}
{             error:=true;
             idstring:='';
           end;}
          inc(c);
        end;
      end;
      error:=(c<46);
      if (not error) and (idstring<>'') and (ord(idstring[1])<>127) then begin
        s:=0;
        for loop:=1 to length(idstring) do
          if (ord(idstring[loop])>123) or (ord(idstring[loop])<31) then s:=s+1;
        if s>3 then exit;
{       while idstring[1]=' ' do delete(idstring,1,1);}
{       while idstring[length(idstring)]=' ' do delete(idstring,length(idstring),1);
       upstr(idstring);
{       if drive=1 then write(outfile,', ');}
       li:=1; {found drive}
       line:=' '+getascii(27,46)+', Port:';
       for i:=1 to length(line)-1 do
         if (line[i]=' ') and (line[i+1]=' ') then begin
           delete(line,i,1);
           if (length(line)>i+1) then dec(i);
         end;
       case ideport of
         $1f0: line:=line+' Primary';
         $170: line:=line+' Secondary';
         $1e8: line:=line+' Tertiary';
         $168: line:=line+' Quaderiary';
       end;
       case drive of
         0: line:=line+' Master';
         1: line:=line+' Slave';
       end;
       line:=line+', Firmware: '+getascii (23,26)+',';
       temp:=' Other: '+getascii (10,19);
       if length(line+temp)>78 then begin
         addline(line);
         line:=' ';
       end;
       addline(line+temp);
{       write(outfile,idstring);}
      end;
    end; {data retrieve}
    inc(attempts);
{    if odd(attempts) then write(#8,' ')
    else write(#8,'.');}
  end;
end;

Function AspiOpen: Integer;           {*************** SCSI ************}
Const
  AspiName: Array [1..9] of Char = 'SCSIMGR$'#0;
var
  AspiHan: Word;
  Aspiptr: pointer;

begin
  With Regs do begin
    { Assume failure }
    AspiOpen := -1;
    AspiPtr := Nil;
    { Open ASPI device driver }
    AX := $3D00;
    DS := Seg (AspiName[1]);
    DX := ofs (AspiName[1]);
    MSDos (Regs);
    if odd (Flags)
      then Exit;
    AspiHan := AX;
    { Do IOCtl Read to get Pointer to ASPI handler }
    AX := $4402;
    BX := AspiHan;
    CX := 4;
    DS := Seg (AspiPtr);
    DX := ofs (AspiPtr);
    MSDos (Regs);
    if Odd (flags)
      then Exit;
  end;
  { Indicate success  and Exit }
  AspiOpen := 0;
  end { AspiOpen };

procedure cleanln(itype:byte);
var byt:byte;
begin
   temp:=copy(line,31,40);
   for i:=1 to length(temp) do begin
     if length(temp)>0 then begin
      byt:=ord(temp[length(temp)]);
      if  (byt<33) or (byt>168) then delete(temp,length(temp),1);
     end;
     byt:=ord(temp[1]);
     if  (byt<33) or (byt>168) then delete(temp,1,1);
    end;
    if itype=5 then scsidrv[n,1]:=scsidrv[n,1]+' '+temp
    else scsidrv[n,itype]:=temp;
end;

procedure Scsi;
var fileinfo:searchrec;
begin
  if aspiopen=-1 then begin
    addline('ASPI (SCSI) driver not found - Remaining drives not found');
    exit;
  end
  else begin
    findfirst('ASPI-ID.EXE',anyfile,fileinfo);
    if doserror<>0 then begin
      addline('ASPI-ID.EXE not found');
      exit;
    end
    else begin
{      writeln('Screen may blank out for a moment...');}
      swapvectors;
      exec(getenv('COMSPEC'),'/C ASPI.BAT');
      swapvectors;
      temp:='';
      if pos('\',fileout)>0 then begin
        temp:=fileout;
        while(temp[length(temp)]<>'\') do delete(temp,length(temp),1);
      end;
      openfi(temp+'ASPI.TXT');
      n:=-1;
      while not eof(infile) do begin
        readln(infile,line);
        if ioresult<>0 then stop(1);
        if line[1]='I' then n:=n+1;
        if length(line)>30 then begin
          if pos('dor ID',line)>0 then cleanln(1);
          if pos('uct ID',line)>0 then cleanln(5);
          if pos('ion Le',line)>0 then cleanln(2);
          if pos('ve Ser',line)>0 then cleanln(3);
          if pos('al Cap',line)>0 then cleanln(4);
        end;
      end;
      close(infile);
      for i:=0 to n do
         if scsidrv[i,1]<>'' then begin
           line:=scsidrv[i,4];
           if line[length(line)-2]=',' then line:=copy(line,1,length(line)-7)
           else line:=copy(line,1,length(line)-8);
           addline('SCSI Drive '+num2str(i+1)+': '+line+' Mb');
           addline(' Info: '+scsidrv[i,1]+', Serial#: '+scsidrv[i,3]+', Firmware: '+scsidrv[i,2]);
           inc(found_drv);
           partition(found_drv,1);
         end;
      regs.ax:=0;  {reset controller+drives}
      regs.dl:=128;
      intr($13,regs);
    end;
  end;
end;

